// *********************************************************************************************************************************
// *********************************************************************************************************************************
// * Script by 		pspsps91
// *********************************************************************************************************************************
// *********************************************************************************************************************************
// * Version:		1.0
// *********************************************************************************************************************************
// *********************************************************************************************************************************
// * Besonderes:	Die Globale Variable KEY bitte nicht benutzen (wird vom Script bentigt!)
// *
// * ---------------------------------------------------------------------------------------------
// *
// * special:		Dont use the global variable KEY (used by the script)
// *********************************************************************************************************************************
// *********************************************************************************************************************************
// * Aktivierung:	nul=[anzahl der Objekte , Position , Klasse der Objekte , Zufllig anordnen(bool)] execVM "nimm_spiel.sqf";
// *			BEISPIEL:
// *			+------------------------------------------------------------------------+
// *			|nul=[20 , (position this) , "Barrels" , false] execVM "nimm_spiel.sqf"; |
// *			+------------------------------------------------------------------------+
// *			-> Den Text in die Initzeile einer Spiellogik oder eines unsichtbaren H kopieren.
// *
// * ---------------------------------------------------------------------------------------------
// *
// * activation:	nul=[number of objects, position , class of objects , random position(bool)] execVM "nimm_spiel.sqf";
// *			EXAMPLE:
// *			+------------------------------------------------------------------------+
// *			|nul=[20 , (position this) , "Barrels" , false] execVM "nimm_spiel.sqf"; |
// *			+------------------------------------------------------------------------+
// *			-> Copy this text into the initline of a gamelogic or an invisible H.
// *********************************************************************************************************************************
// *********************************************************************************************************************************
// * Copyright:		Das verwenden und das Kopieren bzw. Verndern dieses Scripts ist erlaubt.
// *			Allerdings muss ein Verweis auf den Autor (pspsps91) vorhanden sein.
// *
// * ---------------------------------------------------------------------------------------------
// *
// * copyright:		Using, copying or modifying this script is allowed. But you have to refer
// *			to the author (pspsps91).
// *********************************************************************************************************************************
// *********************************************************************************************************************************
// * Disclaimer:	Die Benutzung des Scripts erfolgt auf eigene Gefahr!
// *
// * ---------------------------------------------------------------------------------------------
// *
// * disclaimer:	Use at your own risk!
// *********************************************************************************************************************************
// *********************************************************************************************************************************




////////////////////////////////////////////////////////////////////////////////////////////////////
// *** Hier knnen die Texte, verndert werden fr eine Lokalisierung aus der Stringtable.csv *** //
// *** -------------------------------------------------------------------------------------- *** //
// *** Modify the strings here for a localization from the stringtable.csv for example        *** //
////////////////////////////////////////////////////////////////////////////////////////////////////

//-TEXTE---------------------------------------------------------------
_Regeln      = "Regeln:\n=============\n\nEs gibt eine bestimmte Anzahl an Objekten. Du kannst entweder 1,2 oder 3 Objekte wegnehmen, danach kommt der Computer. Wer das letzte Objekt nimmt gewinnt\n\n\nSteuerung\n=================\n\nBenutze die Tasten 1, 2 und 3 um Objekte zu nehmen.";
_exit        = "Spiel beendet";

_spieler     = "Du bist dran!";
_computer    = "Der Computer ist dran!";
_playerWin   = "DU HAST GEWONNEN!";
_computerWin = "DER COMPUTER HAT GEWONNEN";
//---------------------------------------------------------------------







//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
// *** IN DIESEM BEREICH BITTE NICHTS MEHR VERAENDERN *** ////////////////////////////////////
// *** ---------------------------------------------- *** ////////////////////////////////////
// *** PLEASE DO NOT CHANGE ANYTHING UP TO HERE       *** ////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

// DEFINE
_stCount  = _this select 0;
_stPos    = _this select 1;
_objClass = _this select 2;
_random   = _this select 3;
_disX = 2;
_disY = 2;

_end = false;
_text = [_spieler,_computer,_playerWin,_computerWin];

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
_zugEngine = {									//
	_player = _this select 0;						//
	_total = _this select 1;						//
	_objs = _this select 2;							//
	_input = 0;								//
										//
	if (_player == 0) then {						//
		// human							//
		_input = _total call _getInput;					//
		waitUntil {_input != 0};					//
	} else {								//
		// computer							//
		_input = _total call _zugBot;					//
		waitUntil {_input != 0};					//
	};									//
										//
	_total = _total - _input;						//
										//
										//
	for [{_n=1},{_n<=_input},{_n=_n+1}] do {				//
		_obj = _objs select floor(random (count _objs));		//
		_objs = _objs - [_obj];						//
		_obj call _remove;						//
	};									//
										//
	_total									//
};										//
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
_startGame = {									//
	_total = _this select 0;						//
	_objs = _this select 1;							//
	_text = _this select 2;							//
										//
	_spieler     = (_text select 0);					//
	_computer    = (_text select 1);					//
	_playerWin   = (_text select 2);					//
	_computerWin = (_text select 3);					//
										//
										//
	while {_total > 0} do {							//
		titleText [_spieler,"plain"];					//
		_totalBef = _total;						//
		_total = [0,_total,_objs] call _zugEngine;			//
		WaitUntil {_total != _totalBef};				//
		if (_total <= 0) then {titleText [_playerWin,"Plain"]};		//
										//
		if (_total > 0) then {						//
			titleText [_computer,"plain"];				//
			sleep 3;						//
			_totalBef = _total;					//
			_total = [1,_total,_objs] call _zugEngine;		//
			WaitUntil {_total != _totalBef};			//
			if (_total <= 0) then {titleText [_computerWin,"plain"]};//
		};								//
	};									//
	true									//
};										//
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
_getInput = {									//
	_keys = [2,3,4];							//
	KEY=0;									//
	_zug=0;									//
										//
	// Tastatureingaben							//
	_display = findDisplay 46;						//
	_display displaySetEventHandler ['KeyDown','KEY = (_this select 1)'];	//
										//
	waitUntil {(KEY != 0)&&(KEY in _keys)};					//
	_key = KEY;								//
	if (_key == 2) then {_zug = 1};						//
	if (_key == 3) then {_zug = 2};						//
	if (_key == 4) then {_zug = 3};						//
										//
	_zug									//
};										//
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
_zugBot = {									//
	_total = _this;								//
	_zug = 0;								//
										//
	_zug = _total % 4;							//
	if (_zug == 0) then {_zug = 1};						//
	_zug									//
};										//
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
_remove = {									//
	_obj = _this;								//
	_i = 0;									//
										//
	while {(getpos _obj select 2) > -2} do {				//
		_obj setPos [(getpos _obj select 0),(getpos _obj select 1),_i];	//
		sleep 0.01;							//
		_i = _i - 0.1;							//
	};									//
	DeleteVehicle _obj;							//
};										//
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////



// Kurz warten, falls Script ber init ausgefhrt wird
waitUntil{time>.1};

// Regeln anzeigen
hintC _Regeln;

// Spielfeld erstellen
_objs = [];
_dek = 0;

for [{_n=1},{_n<=_stCount},{_n=_n+1}] do {
	_tempObj = _objClass createVehicle [0,0,0];
	_objs = _objs + [_tempObj];
};

for [{_n=0},{_n<=(floor (sqrt _stCount))},{_n=_n+1}] do {
	for [{_i=0},{_i<=((floor (sqrt _stCount)))},{_i=_i+1}] do {
		_posX = (_stPos select 0) + (_n * _disX);
		_posY = (_stPos select 1) + (_i * _disY);

		if (_random) then {
			// Ungleichmig
			_posX = _posX + (random _disX);
			_posY = _posY + (random _disY);
		};

		if (_dek < count _objs) then {
			(_objs select _dek) setPos [_posX,_posY,0];
			(_objs select _dek) setDir 0;
		};
		_dek = _dek + 1;
	};
};

//////////////////////////////////////////////////////////////////////////
// *** Ansicht erstellen *** /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
_camPos = ((_objs select 0) modelToWorld [-5,-5,5]);
_camPosTarget = "logic" createVehicle [0,0,0];
_camPosTarget setpos ((_objs select 0) modelToWorld [6,6,1]);

_camera = "camera" Camcreate [0,0,0];
_camera CameraEffect ["Internal","Back"];
camUseNVG false;

_camera CamSetPos _camPos;
_camera CamSetTarget _camPosTarget;
_Camera CamCommit 0;
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////


_end = [_stCount,_objs,_text] call _startGame;
WaitUntil {_end};

TitleCut ["\n\n" + _exit,"plain"];

sleep 5;

{Deletevehicle _x} forEach _objs;

_camera CameraEffect ["Terminate","Back"];
CamDestroy _camera;
true